<?php

namespace App\Http\Middleware;

use Closure;
use App\Models\TempCar;
use App\Models\LogApiV2;
//use App\Utilities\CustomLogs;

class TimeTransaction
{
    /**
     * Handle an incoming request.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \Closure  $next
     * @return mixed
     */
    public function handle($request, Closure $next)
    {   
        //Iniciando log
        $log = LogApiV2::initLog($request);

        $response = [
                        'success' => false,
                        'data' => [
                            'cod_err' => 'ERR_PARAM', 
                            'msg' => 'Faltan parámetros.'
                        ]
                    ];

        $inputs = $request->input();

        $transaction = $request->route('transaction') ?? false;

        if(!empty($inputs['transaction']) || $transaction){
            //$transaction = $transaction ? $transaction : $inputs['transaction'];

            if(!empty($transaction)){
                $serv = TempCar::getTempCarAP($transaction);
            }else{
                $serv = TempCar::getTempCarByT($inputs['transaction']);
            }
                                       
            if(!empty($serv)){
                if(strtotime('+'.env('TTL_TRANSACTION', 120).' minutes', strtotime($serv->date_reg)) < time()){
                    $response['data']['cod_err'] = 'TTL_EXPIRED';
                    $response['data']['msg'] = 'Transacción expirada.';
                }
                else{
                    $log->delete();
                    return $next($request);
                }
            }else{
                $response['data']['cod_err'] = 'TR_NOTVALID';
                $response['data']['msg'] = 'Transacción no válida.';
            }
        }

        //Finalizando log
        LogApiV2::finishLog(
            $log, 
            $response, 
            0,
            $response['success'] ? 'D' : 'E',
            !$response['success'] ? $response['data']['msg'] : ''
          );
        
        return response()->json($response);
    }
}
