<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Estafeta extends Model
{
    use HasFactory;

    protected $table = 'islim_estafeta';

    protected $fillable = [
        'client',
        'code',
        'name',
        'final_client',
        'country',
        'region',
        'state',
        'key_state',
        'key_municipe',
        'municipe',
        'key_colony',
        'colony',
        'street',
        'number',
        'street_1',
        'street_2',
        'reference',
        'flat',
        'department',
        'cp',
        'code_region',
        'phone',
        'phone_2',
        'schedule',
        'status'
    ];

    public $timestamps = false;

    public static function getEstafetas($where = false)
    {
        $est = self::distinct()
            ->select(
                'cp',
                'municipe',
                'colony',
                'state',
                'number',
                'street',
                'street_1',
                'street_2',
                'code'
            );
        if ($where)
            $est = $est->where($where);

        return $est->get();
    }

    public static function getEstafetasWSapo($sapo = false, $query = false)
    {
        if ($sapo) {
            if (!$query) {
                $query = [
                    ['state', $sapo->estado],
                    ['municipe', $sapo->municipe],
                    ['colony', $sapo->asenta]
                ];
            }

            $estafetas = self::getEstafetas($query);

            if ($estafetas->count() == 0) {
                array_pop($query);

                if (!empty($query) && count($query))
                    return self::getEstafetasWSapo($sapo, $query);
            } else {
                return $estafetas;
            }
        }

        return [];
    }
}
