<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;

class FiberControl extends Model
{
  protected $table = 'islim_history_fiber_control';

  protected $fillable = [
    'id',
    'user_origin',
    'date_reg',
    'user_destino',
    'installations_id',
    'status',
    'status_control'];

  public $timestamps = false;
/**
 * Metodo para seleccionar conexion a la bd, escritura-lectura o solo escritura
 * @param String $typeCon
 *
 * @return App\FiberControl
 */
  public static function getConnect($typeCon = false)
  {
    if ($typeCon) {
      $obj = new self;
      $obj->setConnection($typeCon == 'W' ? 'mysql::write' : 'mysql::read');
      return $obj;
    }
    return null;
  }

/**
 * [insertHistory Insercion de un nuevo registro de historico de mesa de control]
 * @param  [type] $user_origen  [description]
 * @param  [type] $type_cita    [description]
 * @param  [type] $cita_id      [description]
 * @param  [type] $user_destino [description]
 * @param  [type] $status       [description]
 * @return [type]               [description]
 */
  public static function insertHistory($user_origen, $type_cita, $cita_id, $user_destino = null, $status)
  {

    /*
    DB::connection('netwey-w')
    ->table('islim_history_fiber_control')
    ->insert([
    'installations_id' => $new_install->id,
    'user_origin' => session('user.email'),
    'user_destino' => $request->install_boss,
    'date_reg' => date('Y-m-d H:i:s'),
    'status_control' => 'AB'
    ]);
     */
    if ($type_cita == 'I') { //Instalación
      self::getConnect('W')
        ->where([
          ['installations_id', $cita_id],
          ['status', '!=', 'T']])
        ->update(['status' => 'T']);

      return self::getConnect('W')
        ->insert([
          'installations_id' => $cita_id,
          'user_origin' => $user_origen,
          'user_destino' => $user_destino,
          'date_reg' => date('Y-m-d H:i:s'),
          'status_control' => $status]);

    } else if ($type_cita == 'S'){ //Soporte

      self::getConnect('W')
        ->where([
          ['support_id', $cita_id],
          ['status', '!=', 'T']])
        ->update(['status' => 'T']);

      return self::getConnect('W')
        ->insert([
          'support_id' => $cita_id,
          'user_origin' => $user_origen,
          'user_destino' => $user_destino,
          'date_reg' => date('Y-m-d H:i:s'),
          'status_control' => $status]);
    }
  }

}
