<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Inventory extends Model
{
    use HasFactory;

    protected $table = 'islim_inv_arti_details';

    protected $fillable = [
        'id',
        'parent_id',
        'inv_article_id',
        'warehouses_id',
        'serial',
        'msisdn',
        'iccid',
        'imei',
        'imsi',
        'date_reception',
        'date_sending',
        'price_pay',
        'obs',
        'date_reg',
        'status'
    ];

    public $timestamps = false;

    /**
     * Metodo para seleccionar conexion a la bd, escritura-lectura o solo escritura
     * @param String $typeCon
     * 
     * @return App\models\Inventory
     */
    public static function getConnect($typeCon = false)
    {
        if ($typeCon) {
            $obj = new Inventory;
            $obj->setConnection($typeCon == 'W' ? 'mysql::write' : 'mysql::read');

            return $obj;
        }
        return null;
    }

    public static function getInventoryAva()
    {
        return self::getConnect('R')
            ->select(
                'islim_inv_arti_details.inv_article_id'
            )
            ->join(
                'islim_warehouses',
                'islim_warehouses.id',
                'islim_inv_arti_details.warehouses_id'
            )
            ->where('islim_inv_arti_details.status', 'A')
            ->whereNotNull('islim_warehouses.group')
            ->groupBy('islim_inv_arti_details.inv_article_id')
            ->get();
    }
}
