<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class MPLog extends Model
{
    use HasFactory;

    protected $table = 'islim_mp_log';

    protected $fillable = [
        'transaction',
        'send',
        'received',
        'date_send',
        'date_received',
    ];

    public $timestamps = false;

    /**
     * Metodo para seleccionar conexion a la bd, escritura-lectura o solo escritura
     * @param String $typeCon
     *
     * @return App\models\MPLog
     */
    public static function getConnect($typeCon = false)
    {
        if ($typeCon) {
            $obj = new MPLog;
            $obj->setConnection($typeCon == 'W' ? 'mysql::write' : 'mysql::read');

            return $obj;
        }
        return null;
    }
}
