<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class OrdensDetail extends Model
{
    use HasFactory;

    protected $table = 'islim_orders_details';

    protected $fillable = [
        'id_ordens',
        'id_articles',
        'id_details',
        'id_price',
        'id_sales',
        'dni_client',
        'sku',
        'price',
        'reference',
        'msisdn',
        'lat',
        'lng',
        'serviciability',
        'address',
        'status',
        'car_detail',
    ];

    public $timestamps = false;

    /**
     * Metodo para seleccionar conexion a la bd, escritura-lectura o solo escritura
     * @param String $typeCon
     *
     * @return App\models\OrdensDetail
     */
    public static function getConnect($typeCon = false)
    {
        if ($typeCon) {
            $obj = new OrdensDetail;
            $obj->setConnection($typeCon == 'W' ? 'mysql::write' : 'mysql::read');

            return $obj;
        }
        return null;
    }

    public static function getProductsOrden($idOrder = false)
    {
        if ($idOrder) {
            return self::getConnect('R')
                ->select(
                    'islim_inv_articles.id',
                    'islim_inv_articles.title'
                )
                ->join(
                    'islim_inv_articles',
                    'islim_inv_articles.id',
                    '=',
                    'islim_orders_details.id_articles'
                )
                ->where([['id_ordens', $idOrder]])
                ->get();
        }

        return [];
    }

    //Recibe array que devuelve getDataPayment
    public static function createDetail($data = false, $orden = false)
    {
        if ($data && $orden) {
            $ordenDetail = new OrdensDetail;
            $ordenDetail->id_ordens = $orden->id;
            $ordenDetail->id_articles = $data['artic'];
            $ordenDetail->id_details = $data['serviceId'];
            $ordenDetail->id_price = $data['packPriceId'];
            $ordenDetail->dni_client = $data['dni'];
            $ordenDetail->sku = $data['sku'];
            $ordenDetail->price = $data['pricedetail'];
            $ordenDetail->car_detail = $data['id_detail'];

            if (!empty($data['lat'])) {
                $ordenDetail->lat = $data['lat'];
            }

            if (!empty($data['lat'])) {
                $ordenDetail->lng = $data['lng'];
            }

            if (!empty($data['lat'])) {
                $ordenDetail->serviciability = $data['serviciability'];
            }

            if (!empty($data['address'])) {
                $ordenDetail->address = $data['address'];
            }

            if (!empty($orden->ordNbr)) {
                $ordenDetail->status = $orden->error_verify;
                //Cambiar esto cuando se mas de un articulo en el carrito el -1 es un numero consecutivo
                $ordenDetail->reference = $orden->ordNbr . '-1';
            }

            $ordenDetail->save();

            return $ordenDetail;
        }

        return false;
    }
}
