<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class PCvoywey extends Model
{
    use HasFactory;

    protected $table = 'islim_pcs_vw';

    protected $fillable = [
        'postal_code',
        'colony',
        'municipality',
        'city',
        'state',
        'warehouse',
        'update_date',
        'date_reg',
        'status',
    ];

    public $timestamps = false;

    /**
     * Metodo para seleccionar conexion a la bd, escritura-lectura o solo escritura
     * @param String $typeCon
     *
     * @return App\models\PCvoywey
     */
    public static function getConnect($typeCon = false)
    {
        if ($typeCon) {
            $obj = new PCvoywey;
            $obj->setConnection($typeCon == 'W' ? 'mysql::write' : 'mysql::read');

            return $obj;
        }
        return null;
    }

    public static function getWareHouse($pc)
    {
        return self::getConnect('R')
            ->select('warehouse')
            ->where('postal_code', $pc)
            ->first();
    }

    public static function getWareHouses($pc)
    {
        return self::getConnect('R')
            ->select('warehouse')
            ->where([
                ['postal_code', $pc],
                ['status', 'A']
            ])
            ->orderBy('id', 'DESC')
            ->get();
    }
}
