<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class ServiciabilityBuy extends Model
{
    use HasFactory;

    protected $table = 'islim_serviciability_buy';

    protected $fillable = [
        'id',
        'transaction',
        'serviciability',
        'id_serviciability',
        'lat',
        'lng',
        'address',
        'date_reg',
        'status'
    ];

    public $timestamps = false;

    /**
     * Metodo para seleccionar conexion a la bd, escritura-lectura o solo escritura
     * @param String $typeCon
     * 
     * @return App\models\ServiciabilityBuy
     */
    public static function getConnect($typeCon = false)
    {
        if ($typeCon) {
            $obj = new ServiciabilityBuy;
            $obj->setConnection($typeCon == 'W' ? 'mysql::write' : 'mysql::read');

            return $obj;
        }
        return null;
    }

    /*
		Retorna una direccion validada para servicialidad

		@param String $transaction
		@param String $servId
    */
    public static function getAddressServicibility($transaction = false, $servId = false)
    {
        if ($transaction && $servId) {
            return self::getConnect('R')
                ->where([
                    ['status', 'A'],
                    ['transaction', $transaction],
                    ['id_serviciability', $servId]
                ])
                ->first();
        }

        return null;
    }

    public static function getServiciability($id)
    {
        return self::getConnect('R')
            ->where('id_serviciability', $id)
            ->first();
    }
}
