<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class ShipingMethodsConcentrator extends Model
{
    use HasFactory;

    protected $table = 'islim_shiping_methods_concentrator';

    protected $fillable = [
        'id_concentrator',
        'id_shipping_method',
        'status',
        'date_reg'
    ];

    public $timestamps = false;

    /**
     * Metodo para seleccionar conexion a la bd, escritura-lectura o solo escritura
     * @param String $typeCon
     * 
     * @return App\models\ShipingMethodsConcentrator
     */
    public static function getConnect($typeCon = false)
    {
        if ($typeCon) {
            $obj = new ShipingMethodsConcentrator;
            $obj->setConnection($typeCon == 'W' ? 'mysql::write' : 'mysql::read');

            return $obj;
        }

        return null;
    }

    public static function getMethods($concentrator)
    {
        return self::getConnect('R')
            ->select(
                'islim_shiping_methods.name',
                'islim_shiping_methods.code_name'
            )
            ->join(
                'islim_shiping_methods',
                'islim_shiping_methods.id',
                'islim_shiping_methods_concentrator.id_shipping_method'
            )
            ->where([
                ['islim_shiping_methods.status', 'A'],
                ['islim_shiping_methods_concentrator.status', 'A'],
                ['islim_shiping_methods_concentrator.id_concentrator', $concentrator]
            ])
            ->get();
    }
}
