<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Support\Facades\Log;

class Sms_notification extends Model
{
  use HasFactory;
  protected $table = 'islim_sms_notifications';

  protected $fillable = [
    'id',
    'bash',
    'msisdn',
    'phone_sms',
    'sms_type',
    'concentrator_id',
    'service',
    'sms_attribute',
    'sms',
    'response',
    'status',
    'date_reg',
    'date_process'];

  public $timestamps = false;

  /**
   * Metodo para seleccionar conexion a la bd, escritura-lectura o solo escritura
   * @param String $typeCon
   *
   * @return App\Models\Sms_notification
   */
  public static function getConnect($typeCon = false)
  {
    if ($typeCon) {
      $obj = new Sms_notification;
      $obj->setConnection($typeCon == 'W' ? 'mysql::write' : 'mysql::read');
      return $obj;
    }
    return null;
  }

  public static function Send_sms($DN_netwey, $phone_client, $sms_type, $concentrator_id, $service, $sms_attribute, $sms = '')
  {
    try {
      return self::getConnect('W')
        ->insert([
          'msisdn' => $DN_netwey,
          'phone_sms' => $phone_client,
          'sms_type' => $sms_type,
          'concentrator_id' => $concentrator_id,
          'service' => $service,
          'sms_attribute' => $sms_attribute,
          'sms' => $sms,
          'date_reg' => date('Y-m-d H:i:s')]);
    } catch (Exception $e) {
      $txmsg = "No se pudo crear el registro de envio de sms " . (String) json_encode($e->getMessage());
      Log::error($txmsg);
      return false;
    }
  }

}
