<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class TokenApiSeller extends Model
{
    use HasFactory;

    protected $table = 'islim_token_api_seller';

    protected $fillable = [
        'token',
        'public_token',
        'concentrator_id',
        'type',
        'ipn',
        'send_ipn',
        'use_pm_netwey',
        'deferred',
        'accept_coupon',
        'packs',
        'max_artic',
        'status',
        'date_reg'
    ];

    public $timestamps = false;

    /**
     * Metodo para seleccionar conexion a la bd, escritura-lectura o solo escritura
     * @param String $typeCon
     * 
     * @return App\models\TokenApiSeller
     */
    public static function getConnect($typeCon = false)
    {
        if ($typeCon) {
            $obj = new TokenApiSeller;
            $obj->setConnection($typeCon == 'W' ? 'mysql::write' : 'mysql::read');

            return $obj;
        }
        return null;
    }

    public static function getInfToken($token = false)
    {
        if ($token) {
            $type = (env('APP_ENV') == 'local' || env('APP_ENV') == 'test') ? 'D' : 'P';

            return self::getConnect('R')
                ->select(
                    'islim_token_api_seller.concentrator_id',
                    'islim_token_api_seller.ipn',
                    'islim_token_api_seller.send_ipn',
                    'islim_token_api_seller.use_pm_netwey',
                    'islim_token_api_seller.deferred',
                    'islim_token_api_seller.accept_coupon',
                    'islim_token_api_seller.packs',
                    'islim_token_api_seller.max_artic',
                    'islim_concentrators.name',
                    'islim_token_api_seller.coordination',
                )
                ->join(
                    'islim_concentrators',
                    'islim_concentrators.id',
                    'islim_token_api_seller.concentrator_id'
                )
                ->where([
                    ['islim_token_api_seller.status', 'A'],
                    ['islim_token_api_seller.type', $type],
                    ['islim_token_api_seller.token', $token]
                ])
                ->first();
        }

        return null;
    }

    public static function getInfTokenByPublicToken($token = false)
    {
        if ($token) {
            $type = (env('APP_ENV') == 'local' || env('APP_ENV') == 'test') ? 'D' : 'P';

            return self::getConnect('R')
                ->select(
                    'concentrator_id',
                    'ipn',
                    'send_ipn',
                    'token',
                    'use_pm_netwey'
                )
                ->where([
                    ['status', 'A'],
                    ['type', $type],
                    ['public_token', $token]
                ])
                ->first();
        }

        return null;
    }
}
