<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Warehouse extends Model
{
    use HasFactory;

    protected $table = 'islim_warehouses';

    protected $fillable = [
        'id',
        'name',
        'address',
        'phone',
        'route',
        'street_number',
        'neighborhood',
        'locality',
        'subLocality',
        'state',
        'cp',
        'status'
    ];

    public $timestamps = false;

    /**
     * Metodo para seleccionar conexion a la bd, escritura-lectura o solo escritura
     * @param String $typeCon
     *
     * @return App\models\Warehouse
     */
    public static function getConnect($typeCon = false)
    {
        if ($typeCon) {
            $obj = new Warehouse;
            $obj->setConnection($typeCon == 'W' ? 'mysql::write' : 'mysql::read');

            return $obj;
        }
        return null;
    }
}
