<?php

namespace App\Utilities;

use App\Utilities\Common;
use App\Utilities\CustomLogs;

class Jelou
{
    public static function reportPayment($folio)
    {
        $data = [
            'payment_folio' => $folio
        ];

        $signature = hash_hmac('sha256', json_encode($data), env('SALT_JELOU'));

        $res = Common::executeCurl(
            env('URL_JELOU') . 'nws_webhook',
            'POST',
            [
                "Content-Type: application/json",
                "X-JelouMom-Signature: " . $signature
            ],
            $data
        );

        if (empty($res['code']) || $res['code'] != 200) {
            CustomLogs::registerLogWH('error', 'Falló reporte de pago folio: ' . $folio . ': ' . json_encode($res));
        }

        return true;
    }
}
