<?php
/*DEPRECATED*/

namespace App\Utilities;

use PHPMailer\PHPMailer\PHPMailer;
use PHPMailer\PHPMailer\SMTP;
use PHPMailer\PHPMailer\Exception;

use App\Utilities\CustomLogs;

class SendMail
{
	private static function getMailerSMTP()
	{
		//True activa las exepciones
		$mail = new PHPMailer(true);

		if (env('MAIL_DEBUG'))
			$mail->SMTPDebug = SMTP::DEBUG_SERVER;
		else
			$mail->SMTPDebug = SMTP::DEBUG_OFF;

		$mail->isSMTP();
		$mail->Host = env('MAIL_HOST');
		$mail->SMTPAuth = true;
		$mail->Username = env('MAIL_USERNAME');
		$mail->Password = env('MAIL_PASSWORD');
		$mail->SMTPSecure = PHPMailer::ENCRYPTION_SMTPS;
		$mail->Port = env('MAIL_PORT');

		$mail->setFrom(env('MAIL_FROM_ADDRESS'), env('MAIL_FROM_NAME'));

		return $mail;
	}

	/*
		@param array $address, debe ser del tipo 
		[
			['email' => 'test@test.com', name => 'test'],
			['email' => 'test2@test2.com'],
			.
			.
			.
		]

		@param string $html, html a enviar.

		return boolean
	*/
	public static function sendHTML($address = false, $html = false, $sub = false)
	{
		if (is_array($address) && count($address) && $html && $sub) {
			try {
				$mail = self::getMailerSMTP();

				foreach ($address as $add) {
					if (!empty($add['email'])) {
						$mail->addAddress(
							$add['email'],
							!empty($add['name']) ? $add['name'] : null
						);
					}
				}

				$mail->isHTML(true);
				$mail->Subject = $sub;
				$mail->Body = $html;

				$mail->send();

				return true;
			} catch (Exception $e) {
				CustomLogs::registerLogWH('error', 'Message could not be sent. Mailer Error:' . $mail->ErrorInfo);
			}
		}

		return false;
	}

	public static function sendErrorMakeDel($oper, $transaction)
	{
		$html = '<h1> Error creando delivery ' . $oper . ' desde api seller</h1>';
		$html .= '<p> Error creando el envio para el transaction-id: ' . $transaction;

		self::sendHTML(
			[
				[
					'email' => env('ERROR_ADDRESS'),
					'name' => 'error-netwey',
				],
			],
			$html,
			'Error en creación de delivery ' . $oper . ' - API seller.'
		);
	}
}
