<!DOCTYPE HTML>
<html lang="es">
	<head>
		<meta charset="utf-8">
        <meta http-equiv="X-UA-Compatible" content="IE=edge">
        <meta name="viewport" content="width=device-width, initial-scale=1">

        <title>Pago Netwey-MP</title>

		<style>
			.body-payer{
				margin: 0px;
				color: #FFF;
				font-family: sans-serif;
			}

			.body-payer .container-payer{
				max-width: 450px;
    			margin: 0px auto;
    			background: #696969;
    			padding: 20px 20px;
			}

			.body-payer .container-payer .payer-notification{
				width: 100%;
			    padding: 30px 0px;
			    position: absolute;
			    max-width: 450px;
			    background-color: rgba(0,0,0,.7);
			    top: 120px;
			    border-radius: 10px;
			    display: flex;
			    align-items: center;
			    justify-content: center;
			}

			.body-payer .container-payer .error{
				border: 2px solid #E34C3D; 
			}

			.body-payer .container-payer .success{
				border: 2px solid #00d84d; 
			}

			.body-payer .container-payer .payer-notification .content-notification{
			    width: 100%;
			    text-align: center;
			}

			.body-payer .container-payer .payer-notification .content-notification button{
				background-color: #777777;
			    font-size: 15px;
			    color: white;
			    border-radius: 50px;
			    padding: 3px 20px;
			}

			.body-payer .container-payer .payer-notification .content-notification img{
				width: 65px;
			}

			.body-payer .container-payer .payer-notification .content-notification h2{
				text-transform: uppercase;
			    font-size: 20px;
			    margin: 15px 0px;
			}

			.body-payer .container-payer .loading{
				width: 100%;
			    height: 605px;
			    position: absolute;
			    top: 0px;
			    max-width: 490px;
			    background-color: rgba(0,0,0,.7);
			    left: calc(50vw - 245px);
			}

			.body-payer .container-payer .loading .content-loading{
			    text-align: center;
			    top: calc(50% - 100px);
			    position: relative;
			}

			.body-payer .container-payer .loading .content-loading img{
				width: 150px;
				height: auto;
			}

			.body-payer .c-2{
			    width: 49% !important;
    			display: inline-block;
    		}

			.body-payer .container-payer .title{
				font-size: 22px;
				text-align: center;
				margin: 5px 0px;
			}

			.body-payer .container-payer .form-payer .group-payer{
				padding: 8px 0px;
			}

			.body-payer .container-payer .form-payer .group-payer .i-m{
				width: 24px;
    			display: inline;
			}

			.body-payer .container-payer .form-payer .group-payer .i-y{
				width: 40px;
    			display: inline;
			}

			.body-payer .container-payer .form-payer .group-payer label{
				width: 100%;
				display: inline-block;
				padding-bottom: 5px;
				font-size: 15px;
			}

			.body-payer .container-payer .form-payer .group-payer input, textarea{
				display: block;
			    width: calc(100% - 12px);
			    padding: 0px 5px;
			    font-size: 14px;
			    font-weight: 400;
			    line-height: 1.5;
			    color: #495057;
			    background-color: #fff;
			    background-clip: padding-box;
			    border: 1px solid #ced4da;
			    border-radius: 0.25rem;
			    transition: border-color 0.15s ease-in-out, box-shadow 0.15s ease-in-out;
			}

			.body-payer .container-payer .form-payer .group-payer input{
				height: 25px;
			}

			.body-payer .container-payer .form-payer .btn-content{
				text-align: center;
			}

			.body-payer .container-payer .form-payer .btn-content button{
			    background-color: #00d84d;
			    font-size: 18px;
			    color: white;
			    border-radius: 50px;
			    padding: 3px 20px;
			    margin: 8px 0px;
			}
		</style>
	</head>
	<body class="body-payer">
		<div class="container-payer">
			{{-- Loading --}}
			<div class="loading" id="payer-loading" hidden>
				<div class="content-loading">
					<img src="{{ url('/img/Logotipo-Netwey-Vertical-animado.svg') }}">
                </img>
				</div>
			</div>

			{{-- Notificacion --}}
			@if(!empty($data) || $transactionT->status == 'P')
			<div id="payer-notification" class="payer-notification @if(!empty($data['success']) || $transactionT->status == 'P') success @else error @endif">
				<div class="content-notification">
					@if(!empty((!empty($data) && !$data['success'])) || $transactionT->status != 'P')
						<img src="{{ url('/img/no-ok.png') }}">
					@else
						<img src="{{ url('/img/ok.png') }}">
					@endif

					@if(!empty($data))
						<h2>{!! $data['message'] !!}</h2>
					@elseif($transactionT->status == 'P')
						<h2>La compro ya fue procesada</h2>
					@endif

					@if(!empty($data) && !$data['success'] && $transactionT->status != 'P')
						<button id="try-again">Aceptar</button>
					@endif
				</div>
			</div>
			@endif

			{{-- Formulario de pago --}}
			<h1 class="title">Realizar pago</h1>

			<div>
				<form name="form-payer" id="form-payer" method="POST" class="form-payer">
					<input type="hidden" name="transaction" value="{{ $transaction }}">
					<input type="hidden" name="publicToken" value="{{ $publicToken }}">

					<div class="group-payer">
						<label>Email del cliente</label>
						<input type="text" name="payerEmail" id="payerEmail" placeholder="cliente@correo.com">
					</div>

					<div class="group-payer">
						<label>N&uacute;mero de tarjeta</label>
						<input type="text" id="cardNumber" data-checkout="cardNumber" placeholder="XXXX XXXX XXXX XXXX" onselectstart="return false" onpaste="return false" onCopy="return false" onCut="return false" onDrag="return false" onDrop="return false" autocomplete=off required>
					</div>

					<div class="group-payer">
						<div class="c-2">
							<label>Mes y año de vencimiendo</label>
							<input type="text" id="cardExpirationMonth" class="i-m" data-checkout="cardExpirationMonth" placeholder="MM" maxlength="2" onselectstart="return false" onpaste="return false" onCopy="return false" onCut="return false" onDrag="return false" onDrop="return false" autocomplete=off required>

							<input type="text" id="cardExpirationYear" class="i-y" data-checkout="cardExpirationYear" placeholder="AAAA" maxlength="4" onselectstart="return false" onpaste="return false" onCopy="return false" onCut="return false" onDrag="return false" onDrop="return false" autocomplete=off required>
						</div>

						<div class="c-2">
							<label>C&oacute;digo de seguridad</label>
							<input type="text" id="securityCode" class="i-y" data-checkout="securityCode" placeholder="XXX" maxlength="4" onselectstart="return false" onpaste="return false" onCopy="return false" onCut="return false" onDrag="return false" onDrop="return false" autocomplete=off required>
						</div>
					</div>

					<div class="group-payer">
						<img src="{{ url('/img/tdc-mp.png') }}" width="100%">
					</div>

					<div class="group-payer">
						<label>Nombre del tarjetahabiente:</label>
						<input type="text" data-checkout="cardholderName" placeholder="Nombre indicado en la tarjeta">
					</div>

					<div class="group-payer">
						<label>Direcci&oacute;n registrada con mi tarjeta de cr&eacute;dito o d&eacute;bito</label>
						<textarea class="form-control" name="payerAddress" id="payerAddress" rows="2" placeholder="Ingresa la dirección registrada con tu tarjeta de crédito o débito" autocomplete=off required></textarea>
					</div>

					<div class="group-payer">
						<label>C&oacute;digo postal</label>
						<input type="text" name="payerPostalCode" id="payerPostalCode" placeholder="C&oacute;digo postal" required>
					</div>

					@if((empty($data) || (!empty($data) && !$data['success'])) && $transactionT->status != 'P')
					<div class="btn-content">
						<button type="submit">Pagar</button>
					</div>
					@endif
				</form>
			</div>
		</div>

		@if((empty($data)||(!empty($data)&&!$data['success']))&&$transactionT->status != 'P')
		<script src="https://secure.mlstatic.com/sdk/javascript/v1/mercadopago.js"></script>

		<script type="text/javascript">
			Mercadopago.setPublishableKey("{{env('PUBLICMP')}}");

			function getBin() {
	            var ccNumber = document.querySelector('input[data-checkout="cardNumber"]');
	            return ccNumber.value.replace(/[ .-]/g, '').slice(0, 6);
	        }

	        function guessingPaymentMethod(event) {
	            var bin = getBin();
	            if (event.type == "keyup") {
	                if (bin.length >= 6) {
	                    Mercadopago.getPaymentMethod({
	                        "bin": bin
	                    }, setPaymentMethodInfo);
	                }
	            } else {
	                setTimeout(function() {
	                    if (bin.length >= 6) {
	                        Mercadopago.getPaymentMethod({
	                            "bin": bin
	                        }, setPaymentMethodInfo);
	                    }
	                }, 100);
	            }
	        }

	        Mercadopago.getIdentificationTypes();

	        function setPaymentMethodInfo(status, response) {
	            if(status == 200){
	                var form = document.querySelector('#form-payer');

	                if(document.querySelector("input[name=paymentMethodId]") == null){
	                    var paymentMethod = document.createElement('input');

	                    paymentMethod.setAttribute('name', "paymentMethodId");
	                    paymentMethod.setAttribute('type', "hidden");
	                    paymentMethod.setAttribute('value', response[0].id);

	                    form.appendChild(paymentMethod);
	                }else{
	                    document.querySelector("input[name=paymentMethodId]").value = response[0].id;
	                }
	            }
	        }

	        function addEvent(el, eventName, handler){
	            if(el && el.addEventListener){
	               el.addEventListener(eventName, handler);
	            }else if(el){
	                el.attachEvent('on' + eventName, function(){
	                  handler.call(el);
	                });
	            }
	        }

	        @if(!empty($data))
	        addEvent(
	        	document.querySelector('#try-again'),
	        	'click',
	        	hideNotification);
	        @endif

	        addEvent(
	        	document.querySelector('input[data-checkout="cardNumber"]'),
	        	'keyup',
	        	guessingPaymentMethod);

        	addEvent(
        		document.querySelector('input[data-checkout="cardNumber"]'), 
        		'change', 
        		guessingPaymentMethod);

        	addEvent(document.querySelector('#form-payer'),'submit',doPay);

        	var firts = true,
        		isProcces = false;
	        function doPay(event){
	            event.preventDefault();
	            if(firts && !isProcces){
	            	document.querySelector('#payer-loading').removeAttribute('hidden');

	            	isProcces = true;

	                var $form = document.querySelector('#form-payer');

	                Mercadopago.createToken($form, sdkResponseHandler);
	            }else if(!isProcces){
	            	firts = true;
	            	document.querySelector('#form-payer').submit();
	            }
	                
	            return false;
	        }

	        function sdkResponseHandler(status, response){
	            if(status != 200 && status != 201){
	            	firts = true;
	            	isProcces = false;

	            	document.querySelector('#payer-loading').setAttribute('hidden','true');

	                alert("Datos no válidos, verifique la información.");
	            }else{
	                var form = document.querySelector('#form-payer'),
	                	card = document.createElement('input'),
	                	lastFourDigits = document.createElement('input');

	                card.setAttribute('name',"token");
	                card.setAttribute('type',"hidden");
	                card.setAttribute('value',response.id);

	                form.appendChild(card);

	                lastFourDigits.setAttribute('name',"last_four_digits");
	                lastFourDigits.setAttribute('type',"hidden");
	                lastFourDigits.setAttribute('value',response.last_four_digits);

	                form.appendChild(lastFourDigits);

	                firts = false;
	                isProcces = false;

	                form.setAttribute('action', "{{ route('processPayment') }}");
	                document.querySelector('#form-payer').submit();
	            }
	        }

	        @if(!empty($data))
	        function hideNotification(ele = false){
	        	if(document.querySelector('#payer-notification'))
	        		document.querySelector('#payer-notification')
	        				.setAttribute('style','display:none !important;');
	        }
	        @endif
		</script>
		@endif
	</body>
</html>