<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\BuyController;
use App\Http\Controllers\BuyControllerProof;
use App\Http\Controllers\PayController;
use App\Http\Controllers\ClientController;
use App\Http\Controllers\ShippingController;
use App\Http\Controllers\TestController;

Route::group(['middleware' => ['BearerAuth']], function () {
    /*Request de servicialidad 1 paso para una compra HBB*/
    Route::post('/serviciability', [BuyController::class, 'serviciability']);

    /*Request de servicialidad 1 paso para una compra MBB o MIFI*/
    Route::post('/get-articles', [BuyController::class, 'getArticles']);

    /*Request para registar un pago*/
    Route::post('/register-payment', [PayController::class, 'registerPayment']);

    /*Actualiza el estatus de un pago diferido*/
    Route::post('/mark-payment', [PayController::class, 'markPayment']);

    /*Consulta estatus de una orden*/
    Route::post('/get-order-status', [BuyController::class, 'getOrderStatus']);

    /*Consulta estatus de una orden*/
    Route::post('/serviciabilityProof', [BuyControllerProof::class, 'serviciabilityProof']);

    /*Consulta el codigo referido del cliente*/
    Route::post('/get-client-code', [ClientController::class, 'getClientCode']);

});


    /*rutas Api Fibra*/
    require_once 'apis/fiber.php';


Route::group(['middleware' => ['BearerAuth', 'TimeTransaction']], function () {
    /*Request de seleccion de equipo*/
    Route::post('/select-device', [BuyController::class, 'selectDevice']);

    /*Request para consultar cliente*/
    Route::post('/get-client', [ClientController::class, 'getClient']);

    /*Request para actualizar email de cliente*/
    Route::post('/update-email-client', [ClientController::class, 'updateEmailClient']);

    /*Request para registrar un cliente*/
    Route::post('/register-client', [ClientController::class, 'registerClient']);

    /*Request para asignar un cliente a una transaccion*/
    Route::post('/assign-client', [BuyController::class, 'assignClient']);

    /*Request para consultar metodos de envío*/
    Route::post('/get-shipping-methods', [ShippingController::class, 'getShippingMethods']);

    /*Request para registrar un envío*/
    Route::post('/register-shipping', [ShippingController::class, 'registerShipping']);
});

Route::group(['middleware' => ['TimeTransaction']], function () {
    /*Retorna html para pago por mercado pago*/
    Route::get('/get-payment-url/{transaction}/{publicToken}', [PayController::class, 'getPaymentUrl'])->name('getPaymentUrl');

    /*Procesa pago hecho por mercado pago desde el formulario get-payment-url*/
    Route::post('/process-payment', [PayController::class, 'processPayment'])->name('processPayment');
});

/*Ruta para probar data enviada al ipn*/
//Route::post('/test-ipn', [TestController::class, 'testIPN']);

/*Ruta para probar email*/
//Route::post('/test-mail', [TestController::class, 'testMail']);

/*Ruta test*/
Route::post('/test-test', [TestController::class, 'testTest']);
/*Ruta alternativa para pruebas */
Route::get('/debug', [TestController::class, 'debug_test']);
